FUNCTION_BLOCK W_to_B_OFF
  VAR_INPUT
    In0 : WORD;
  END_VAR
  VAR
    Val_comp : WORD := 32753;
    Val0 : BOOL;
    Out0 : BOOL := false;
    Out1 : BOOL := true;
  END_VAR
  VAR_OUTPUT
    Out : BOOL;
  END_VAR

  IF In0 < Val_comp THEN
    Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK

FUNCTION_BLOCK AND_var_T
  VAR
    Var0 : BOOL;
    Val0 : BOOL;
  END_VAR
  VAR_INPUT
    In0 : BOOL;
    In1 : BOOL;
  END_VAR
  VAR
    Var_t : BOOL := true;
    Var_f : BOOL := false;
    Out0 : BOOL := false;
    Out1 : BOOL := true;
  END_VAR
  VAR_OUTPUT
    Out : BOOL;
  END_VAR

  IF In0 = Var_t AND In1 = Var_t THEN
      Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK

FUNCTION_BLOCK W_to_B_ON
  VAR_INPUT
    In0 : WORD;
  END_VAR
  VAR
    Val_comp : WORD := 32753;
    Val0 : BOOL;
    Out0 : BOOL := false;
    Out1 : BOOL := true;
  END_VAR
  VAR_OUTPUT
    Out : BOOL;
  END_VAR

  IF In0 > Val_comp THEN
    Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK

FUNCTION_BLOCK B_to_W_ON_OFF
  VAR_INPUT
    In0 : BOOL;
    In1 : BOOL;
  END_VAR
  VAR
    Val0 : WORD;
    Val1 : BOOL := true;
    Val2 : BOOL := false;
    Val3 : BOOL;
    Out0 : WORD := 0;
    Out1 : WORD := 65535;
  END_VAR
  VAR_OUTPUT
    Out : WORD;
    Out2 : BOOL;
  END_VAR

  IF In0 THEN
    Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;

  IF In1 THEN
    Val3 := Val2;
  ELSE
    Val3 := Val1;
  END_IF;

  Out2 := Val3;
END_FUNCTION_BLOCK

FUNCTION_BLOCK B_to_W_ON
  VAR_INPUT
    In0 : BOOL;
  END_VAR
  VAR
    Val0 : WORD;
    Out0 : WORD := 0;
    Out1 : WORD := 65535;
  END_VAR
  VAR_OUTPUT
    Out : WORD;
  END_VAR

  IF In0 THEN
    Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK

FUNCTION_BLOCK AND_var_F
  VAR
    Var0 : BOOL;
    Val0 : BOOL;
  END_VAR
  VAR_INPUT
    In0 : BOOL;
    In1 : BOOL;
  END_VAR
  VAR
    Var_t : BOOL := true;
    Var_f : BOOL := false;
    Out0 : BOOL := false;
    Out1 : BOOL := true;
  END_VAR
  VAR_OUTPUT
    Out : BOOL;
  END_VAR

  IF In0 = Var_t AND In1 = Var_f THEN
      Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK

PROGRAM PLC_Traffic_UNO
  VAR
    Status : BOOL := true;
  END_VAR
  VAR
    O_LEDRed AT %QW103 : WORD;
    O_LEDOrange AT %QW102 : WORD;
    O_LEDGreen AT %QW101 : WORD;
  END_VAR
  VAR
    TOF0 : TOF;
    B_to_W_ON4 : B_to_W_ON;
    W_to_B_ON0 : W_to_B_ON;
    F_TRIG0 : F_TRIG;
    F_TRIG2 : F_TRIG;
    W_to_B_ON2 : W_to_B_ON;
    B_to_W_ON5 : B_to_W_ON;
    TOF2 : TOF;
    F_TRIG3 : F_TRIG;
    W_to_B_ON3 : W_to_B_ON;
    TOF3 : TOF;
    AND_var_F0 : AND_var_F;
    W_to_B_ON4 : W_to_B_ON;
    B_to_W_ON_OFF0 : B_to_W_ON_OFF;
    AND_var_T0 : AND_var_T;
    OR63_OUT : BOOL;
  END_VAR

  W_to_B_ON0(In0 := O_LEDOrange);
  F_TRIG0(CLK := W_to_B_ON0.Out);
  AND_var_T0(In0 := F_TRIG0.Q, In1 := Status);
  TOF0(IN := AND_var_T0.Out, PT := T#3s);
  B_to_W_ON4(In0 := TOF0.Q);
  O_LEDRed := B_to_W_ON4.Out;
  W_to_B_ON3(In0 := O_LEDOrange);
  F_TRIG3(CLK := W_to_B_ON3.Out);
  AND_var_F0(In0 := F_TRIG3.Q, In1 := Status);
  TOF3(IN := AND_var_F0.Out, PT := T#3s);
  B_to_W_ON5(In0 := TOF3.Q);
  O_LEDGreen := B_to_W_ON5.Out;
  W_to_B_ON2(In0 := O_LEDGreen);
  W_to_B_ON4(In0 := O_LEDRed);
  OR63_OUT := OR(W_to_B_ON2.Out, W_to_B_ON4.Out);
  F_TRIG2(CLK := OR63_OUT);
  TOF2(IN := F_TRIG2.Q, PT := T#1s);
  B_to_W_ON_OFF0(In0 := TOF2.Q, In1 := Status);
  O_LEDOrange := B_to_W_ON_OFF0.Out;
  Status := B_to_W_ON_OFF0.Out2;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK task0(INTERVAL := T#20ms,PRIORITY := 0);
    PROGRAM instance0 WITH task0 : PLC_Traffic_UNO;
  END_RESOURCE
END_CONFIGURATION
