void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->ADD10_OUT,0,retain)
  __INIT_VAR(data__->EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SEL15_OUT,0,retain)
  __INIT_VAR(data__->AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->ADD10_OUT,)));
  __SET_VAR(data__->,SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (UINT)__GET_VAR(data__->ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->SEL15_OUT,));
  __SET_VAR(data__->,AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void W_TO_B_OFF_init__(W_TO_B_OFF *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,0,retain)
  __INIT_VAR(data__->VAL_COMP,32753,retain)
  __INIT_VAR(data__->VAL0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT1,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void W_TO_B_OFF_body__(W_TO_B_OFF *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->IN0,) < __GET_VAR(data__->VAL_COMP,))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // W_TO_B_OFF_body__() 





void AND_VAR_T_init__(AND_VAR_T *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->VAR0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAR_T,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->VAR_F,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT1,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void AND_VAR_T_body__(AND_VAR_T *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if (((__GET_VAR(data__->IN0,) == __GET_VAR(data__->VAR_T,)) && (__GET_VAR(data__->IN1,) == __GET_VAR(data__->VAR_T,)))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // AND_VAR_T_body__() 





void W_TO_B_ON_init__(W_TO_B_ON *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,0,retain)
  __INIT_VAR(data__->VAL_COMP,32753,retain)
  __INIT_VAR(data__->VAL0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT1,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void W_TO_B_ON_body__(W_TO_B_ON *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->IN0,) > __GET_VAR(data__->VAL_COMP,))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // W_TO_B_ON_body__() 





void B_TO_W_ON_OFF_init__(B_TO_W_ON_OFF *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL0,0,retain)
  __INIT_VAR(data__->VAL1,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->VAL2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,0,retain)
  __INIT_VAR(data__->OUT1,65535,retain)
  __INIT_VAR(data__->OUT,0,retain)
  __INIT_VAR(data__->OUT2,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void B_TO_W_ON_OFF_body__(B_TO_W_ON_OFF *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if (__GET_VAR(data__->IN0,)) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));
  if (__GET_VAR(data__->IN1,)) {
    __SET_VAR(data__->,VAL3,,__GET_VAR(data__->VAL2,));
  } else {
    __SET_VAR(data__->,VAL3,,__GET_VAR(data__->VAL1,));
  };
  __SET_VAR(data__->,OUT2,,__GET_VAR(data__->VAL3,));

  goto __end;

__end:
  return;
} // B_TO_W_ON_OFF_body__() 





void B_TO_W_ON_init__(B_TO_W_ON *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->IN0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL0,0,retain)
  __INIT_VAR(data__->OUT0,0,retain)
  __INIT_VAR(data__->OUT1,65535,retain)
  __INIT_VAR(data__->OUT,0,retain)
}

// Code part
void B_TO_W_ON_body__(B_TO_W_ON *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if (__GET_VAR(data__->IN0,)) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // B_TO_W_ON_body__() 





void AND_VAR_F_init__(AND_VAR_F *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->VAR0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAL0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VAR_T,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->VAR_F,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT1,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void AND_VAR_F_body__(AND_VAR_F *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if (((__GET_VAR(data__->IN0,) == __GET_VAR(data__->VAR_T,)) && (__GET_VAR(data__->IN1,) == __GET_VAR(data__->VAR_F,)))) {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT1,));
  } else {
    __SET_VAR(data__->,VAL0,,__GET_VAR(data__->OUT0,));
  };
  __SET_VAR(data__->,OUT,,__GET_VAR(data__->VAL0,));

  goto __end;

__end:
  return;
} // AND_VAR_F_body__() 





void PLC_TRAFFIC_UNO_init__(PLC_TRAFFIC_UNO *data__, BOOL retain) {
  __INIT_VAR(data__->STATUS,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->O_LEDRED,0,retain)
  __INIT_VAR(data__->O_LEDORANGE,0,retain)
  __INIT_VAR(data__->O_LEDGREEN,0,retain)
  TOF_init__(&data__->TOF0,retain);
  B_TO_W_ON_init__(&data__->B_TO_W_ON4,retain);
  W_TO_B_ON_init__(&data__->W_TO_B_ON0,retain);
  F_TRIG_init__(&data__->F_TRIG0,retain);
  F_TRIG_init__(&data__->F_TRIG2,retain);
  W_TO_B_ON_init__(&data__->W_TO_B_ON2,retain);
  B_TO_W_ON_init__(&data__->B_TO_W_ON5,retain);
  TOF_init__(&data__->TOF2,retain);
  F_TRIG_init__(&data__->F_TRIG3,retain);
  W_TO_B_ON_init__(&data__->W_TO_B_ON3,retain);
  TOF_init__(&data__->TOF3,retain);
  AND_VAR_F_init__(&data__->AND_VAR_F0,retain);
  W_TO_B_ON_init__(&data__->W_TO_B_ON4,retain);
  B_TO_W_ON_OFF_init__(&data__->B_TO_W_ON_OFF0,retain);
  AND_VAR_T_init__(&data__->AND_VAR_T0,retain);
  __INIT_VAR(data__->OR63_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PLC_TRAFFIC_UNO_body__(PLC_TRAFFIC_UNO *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->W_TO_B_ON0.,IN0,,__GET_VAR(data__->O_LEDORANGE,));
  W_TO_B_ON_body__(&data__->W_TO_B_ON0);
  __SET_VAR(data__->F_TRIG0.,CLK,,__GET_VAR(data__->W_TO_B_ON0.OUT,));
  F_TRIG_body__(&data__->F_TRIG0);
  __SET_VAR(data__->AND_VAR_T0.,IN0,,__GET_VAR(data__->F_TRIG0.Q,));
  __SET_VAR(data__->AND_VAR_T0.,IN1,,__GET_VAR(data__->STATUS,));
  AND_VAR_T_body__(&data__->AND_VAR_T0);
  __SET_VAR(data__->TOF0.,IN,,__GET_VAR(data__->AND_VAR_T0.OUT,));
  __SET_VAR(data__->TOF0.,PT,,__time_to_timespec(1, 0, 3, 0, 0, 0));
  TOF_body__(&data__->TOF0);
  __SET_VAR(data__->B_TO_W_ON4.,IN0,,__GET_VAR(data__->TOF0.Q,));
  B_TO_W_ON_body__(&data__->B_TO_W_ON4);
  __SET_VAR(data__->,O_LEDRED,,__GET_VAR(data__->B_TO_W_ON4.OUT,));
  __SET_VAR(data__->W_TO_B_ON3.,IN0,,__GET_VAR(data__->O_LEDORANGE,));
  W_TO_B_ON_body__(&data__->W_TO_B_ON3);
  __SET_VAR(data__->F_TRIG3.,CLK,,__GET_VAR(data__->W_TO_B_ON3.OUT,));
  F_TRIG_body__(&data__->F_TRIG3);
  __SET_VAR(data__->AND_VAR_F0.,IN0,,__GET_VAR(data__->F_TRIG3.Q,));
  __SET_VAR(data__->AND_VAR_F0.,IN1,,__GET_VAR(data__->STATUS,));
  AND_VAR_F_body__(&data__->AND_VAR_F0);
  __SET_VAR(data__->TOF3.,IN,,__GET_VAR(data__->AND_VAR_F0.OUT,));
  __SET_VAR(data__->TOF3.,PT,,__time_to_timespec(1, 0, 3, 0, 0, 0));
  TOF_body__(&data__->TOF3);
  __SET_VAR(data__->B_TO_W_ON5.,IN0,,__GET_VAR(data__->TOF3.Q,));
  B_TO_W_ON_body__(&data__->B_TO_W_ON5);
  __SET_VAR(data__->,O_LEDGREEN,,__GET_VAR(data__->B_TO_W_ON5.OUT,));
  __SET_VAR(data__->W_TO_B_ON2.,IN0,,__GET_VAR(data__->O_LEDGREEN,));
  W_TO_B_ON_body__(&data__->W_TO_B_ON2);
  __SET_VAR(data__->W_TO_B_ON4.,IN0,,__GET_VAR(data__->O_LEDRED,));
  W_TO_B_ON_body__(&data__->W_TO_B_ON4);
  __SET_VAR(data__->,OR63_OUT,,OR__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->W_TO_B_ON2.OUT,),
    (BOOL)__GET_VAR(data__->W_TO_B_ON4.OUT,)));
  __SET_VAR(data__->F_TRIG2.,CLK,,__GET_VAR(data__->OR63_OUT,));
  F_TRIG_body__(&data__->F_TRIG2);
  __SET_VAR(data__->TOF2.,IN,,__GET_VAR(data__->F_TRIG2.Q,));
  __SET_VAR(data__->TOF2.,PT,,__time_to_timespec(1, 0, 1, 0, 0, 0));
  TOF_body__(&data__->TOF2);
  __SET_VAR(data__->B_TO_W_ON_OFF0.,IN0,,__GET_VAR(data__->TOF2.Q,));
  __SET_VAR(data__->B_TO_W_ON_OFF0.,IN1,,__GET_VAR(data__->STATUS,));
  B_TO_W_ON_OFF_body__(&data__->B_TO_W_ON_OFF0);
  __SET_VAR(data__->,O_LEDORANGE,,__GET_VAR(data__->B_TO_W_ON_OFF0.OUT,));
  __SET_VAR(data__->,STATUS,,__GET_VAR(data__->B_TO_W_ON_OFF0.OUT2,));

  goto __end;

__end:
  return;
} // PLC_TRAFFIC_UNO_body__() 





